

.equ left=11
.equ top=6

play_blm_pm_z:
  play_blm_frame:       
   LDI r21,left
   play_blm_column:
    LDI r22,top
    LPM r16,Z+
    play_blm_pixel:
      MOV r20,r16
      ANDI r20,128
      LDI r17,' '
      CPI r20,0
      BREQ play_blm_pixel_off
        LDI r17,'#'
      play_blm_pixel_off:
      STS text_pos_x,r21
      STS text_pos_y,r22
      call get_char_pointer_x
      ST X,r17
      
      LSL r16
      inc r22
      CPI r22,top+8
      BRLT play_blm_pixel
      
    INC r21
    CPI r21,left+18
    BRLT play_blm_column

   LPM r16,Z+
   play_blm_delay:
    call sleep_frame
    DEC r16
    BRNE play_blm_delay    
    
   LDS r16,key_buffer
   CPI r16,kesc
   BREQ play_blm_end
       
   LPM r16,Z+
   CPI r16,0
   BREQ play_blm_frame
  play_blm_end:
ret
    
play_blm_chat_noir:
    
    call blm_drawbackground

    LDI zh,high(james_blond*2)
    LDI zl, low(james_blond*2);
    call play_blm_pm_z
    call get_key_r17
    CPI r17,27
    BRNE play_blm_chat_noir
    ret
    
    
blm_drawbackground:
    call clear_screen
    LDI r17,0
    STS text_pos_x,r17
    STS text_pos_y,r17
    LDI zl,low(blm_background_chars*2)
    LDI zh,high(blm_background_chars*2)
    LDI r20,19    
    
  blm_drawbackground_line:    
    LPM r17,Z+
    LDI r21,39
    blm_drawbackground_char:
      call out_char_r17
      DEC r21
      BRNE blm_drawbackground_char
    call text_cr_lf
    DEC r20
    BRNE blm_drawbackground_line    

    ret

blm_background_chars:    
.db "  ....--++****+++---"
    
;.include "chat_noir.asm" 

james_blond:   
;.include "james_blond.asm"    Aus Urheberrechtlichen Gruenden nicht dabei


    