;Character/Graphics generator


.macro outchar	
    LD	r1,X+		;2
    OUT	video,r1	;1 0
    LSR	r1		;1
    OUT video,r1	;1 1
    LSR r1		;1
    OUT video,r1       ;1 2
    LSR r1		;1
    OUT video,r1       ;1 3
    LSR r1		;1
    OUT video,r1       ;1 4 
    LSR r1		;1 #12
    OUT video,r1       ;1 5 
    LSR r1		;1
    OUT video,r1       ;1 6 
    LSR r1		;1
    OUT video,r1       ;1 7
                        ; 17 TZ
.endmacro

.macro line
    LDI xh,high(line_buffer) 	;1  X auf Zeilenbuffer
    LDI xl,low(line_buffer)	;1
    ;LDI	xh,0
    ;LDI	xl,0
  
    outchar
    outchar
    outchar
    outchar
    outchar ;#5
    outchar
    outchar
    outchar
    outchar
    outchar ;#10
    outchar 
    outchar
    outchar
    outchar
    outchar ;#15
    outchar
    outchar
    outchar
    outchar
    outchar ;#20
    outchar
    outchar
    outchar
    outchar
    outchar ;#25
    outchar
    outchar
    outchar
    outchar
    outchar ;#30
    outchar
    outchar
    outchar
    outchar
    outchar ;#35
    outchar
    outchar
    outchar
    outchar
    outchar ;#40
    CBI	video,0
    ;#17*40+4=684
.endmacro			
			
.macro chargen
       LD Zl,Y+       ;#2 TZ   Y ist Zeiger auf Buchstabe
       LPM r1,Z       ;#3 TZ   Z ist Zeiger auf Zeichensatz
       ST X+,r1       ;#2 TZ   X ist Bitmapbuffer
      ;#7 TZ
.endmacro

.macro chargen_40char
    LDI xh,high(line_buffer) 	;1  X auf Zeilenbuffer
    LDI xl,low(line_buffer)	;1
    chargen
    chargen
    chargen
    chargen
    chargen ;#5
    chargen
   syncein  ;TZ 44
    chargen
    chargen
    chargen
    chargen ;#10
    chargen
;    chargen
    LD Zl,Y+       ;#2 TZ   Y ist Zeiger auf Buchstabe
    LPM r1,Z       ;#3 TZ   Z ist Zeiger auf Zeichensatz
   syncaus    
    ST X+,r1       ;#2 TZ   X ist Bitmapbuffer    
;  syncaus    
    chargen
    chargen
    chargen ;#15
    chargen
    chargen
    chargen
    chargen
    chargen ;#20
    chargen
    chargen
    chargen
    chargen
    chargen ;#25
    chargen
    chargen
    chargen
    chargen
    chargen ;#30
    chargen
    chargen
    chargen
    chargen
    chargen ;#35
    chargen
    chargen
    chargen
    chargen
    chargen ;#40
    ;#40*7+2+2+1+1=286
.endmacro


;textline:
;    chargen_40char    ;#280 TZ
;    
;    line              ;#682 TZ
;    CBI video,0	      ;2
;    ret		      ;#4 TZ
                     ;########TZ neu berechnen###
    
delay_10_tz: ;4 fuer call 4 fure ret
    nop
    nop
    ret    
    
drawimage:  ;  4 fuer Call
    PUSH r17  ;2
    PUSH r18  ;2
    PUSH r1   ;2
    
    PUSH xh   ;2
    PUSH xl   ;2
    PUSH yh   ;2
    PUSH yl   ;2
    PUSH zh   ;2
    PUSH zl   ;2
              ;=22 TZ 
    ; Synkronisationsimpulse vor dem Bild
    ; wegen Jitter
    ;jmp imagestart ;zumTest
    
        
    ldi	r18,synclines ;Anzahl der Zeilen vor dem Bild ;23 TZ nach hsyncende=67 seit hsync Anfang
  drawimage_vorzeile1:
    audio_pm_15625Hz
    nop

    ldi	r17,229 -5 ;\ 223*4 Taktzyklen warten
    sleep_r17   ; \
    nop         ; / 892
;    nop     ;/
    dec	r18
    ;62 TZ zu hsync
    BREQ imagestart      ;	r18=0!
    ;61 TZ zu hsync
    ldi r17,14 ;14 ;60 TZ
    sleep_r17
    
    hsync      ;44 TZ
    ;ldi r17,5 ;\
    ;sleep_r17 ;/ 20 TZ
    jmp	drawimage_vorzeile1 ;3 TZ
    
  imagestart:; 60 TZ zu hsync    
    LDI	r18,0
  linestart: ;von hier in 59 TZ hsyncbeginn
    mov	r17,r18                   	;1
    LSR	r17 ; \                   	;1
    LSR	r17 ;  >/8                	;1
    LSR r17 ; /				;1
    LSL r17 ; *2			;1
    LDI	zh,high(line_pointers)		;1
    LDI zl,low(line_pointers)		;1
    ADD zl,r17				;1
    LD yl,Z+				;2
    LD yh,Z				;2
    mov r17,r18				;1
    ANDI r17,7				;1
    LDI zh,high(font_rom*2)		;1
    add zh,r17				;1
    chargen_40char			;286 sync ; sync nach 44 TZ
    line				;684
;-------------------------------
        ;32 TZ frei evtl Cursor noch machen, dann sleep kuerzer
    LDI r17,8 -5
    sleep_r17    

    audio_pm_15625Hz
    nop

;---------------------------	
    
    inc r18				;1
    CPI r18,linecount*8			;1
    BREQ ende				;1/2
    jmp linestart			;3
                                        ;Summe: 1024
  ende:
    ldi r17,32 ;damit naechsterIRQ passt
    sleep_r17
    POP zl
    POP zh
    POP yl
    POP yh
    POP xl
    POP xh
    POP r1
    POP r18
    POP r17
    ret  
