;Praesentationsprogramm
;wird aus main.asm includiert
;
;Format im Speicher
;|:Steuerzeichen,0-terminierter String:|


.cseg

startlogo:
    LDI Zh,high(fh_logo*2)
    LDI Zl,low(fh_logo*2)
    rjmp praesentation_schleife

praesentation:
    LDI Zh,high(prae_dat*2)
    LDI Zl,low(prae_dat*2)
praesentation_schleife:
    LPM r17,Z+
;    call out_char_r17
    CPI r17,0
    BREQ praesentation_schleife ;Nullzeichen rausbringen
    CPI r17,'E'
    BREQ praesentation_ende
    CPI r17,'W'
    BREQ praesentation_waitkeyloop
    CPI r17,'C'
    BREQ praesentation_clear_screen
    ;sonst normale Ausgabe
    rjmp praesentation_ausgabe
praesentation_waitkeyloop:
    call sleep_frame
    call get_key_r17    
    CPI r17,0
    BREQ praesentation_waitkeyloop
    CPI r17,kesc
    BREQ praesentation_ende

praesentation_leerzeilen:
        
praesentation_ausgabe:
    call write_string_z_pm
    call text_cr_lf
    call sleep_01s
    jmp praesentation_schleife

praesentation_ende:
    ret
    
praesentation_clear_screen:
    call clear_screen
    rjmp praesentation_schleife

    
    
prae_dat:
.db "C ",0
.db "  #################################### ",0
.db " #                                    #",0
.db " #        EINCHIPVIDEOCOMPUTER        #",0
.db " #                                    #",0
.db " #                                    #",0
.db " #    Eine Spiellerei im Rahmen des   #",0 
.db " #               Faches               #",0
.db " #   Vertiefung Microcomputertechnik  #",0
.db " #                                    #",0
.db " #           Christian Berger         #",0
.db " #                                    #",0
.db "  #################################### ",0
.db "W ",0
.db "C ",0
.db " ######################################",0
.db " #       Funktionsbeschreibung        #",0
.db " ######################################",0
.db "W ",0
.db "  ",0
.db " * Behandlung einer normalen ",0
.db "     AT-Tastatur",0
.db "  ",0
.db "W* Bildausgabe auf einem Fernsehger",$E4,"t",0
.db "W ",0
.db "C ",0
.db " ######################################",0
.db " #        Tastaturbehandlung          #",0
.db " ######################################",0
.db "  ",0
.db "  ",0
.db "W* Einlesen der Bytes von der Tastatur",0
.db "  ",0
.db "W* Unwichtige Bytes wegwerfen",0
.db "  ",0
.db "W* Break-Codes behandeln",0
.db "  ",0
.db "W* Make-Codes in Tabelle nachschlagen",0
.db "  ",0
.db "W* ASCII-Code in 'Ringbuffer'",0
.db "W ",0
.db "C ",0
.db " ######################################",0
.db " #    Bildausgabe auf Fernsehger",$E4,"t    #",0
.db " ######################################",0
.db " ",0
.db " ",0
.db "W* 40x20 Zeichen",0
.db " ",0
.db "W* 'Bild' als ASCII-Zeichen im Speicher",0
.db " ",0
.db "W* 20x40 Byte im Speicher",0
.db "   keine 256 Byte-Grenze ",$FC,"berschritten",0
.db " ",0
.db "W* 20 Zeiger f",$FC,"r die Zeilen",0
.db "   dadurch einige Effektm",$F6,"glichkeiten",0
.db "W  ",0
.db "C  ",0
.db " ######################################",0
.db " #       Details der Bildausgabe      #",0
.db " ######################################",0
.db "   ",0
.db "   ",0
.db "W* Controller l",$E4,"uft mit 16 MHz",0
.db "   1 Zeile = 1024 Taktzyklen",0
.db "   ",0
.db "W* In dunklen Bereichen einfach ",0
.db "   Synchronsignal ausgeben",0
.db "   ",0
.db "W* Im Bildbereich: ",0
.db "   * Zeichen aus RAM lesen",0
.db "   * Zeichen im ROM nachschlagen",0
.db "   * nachgeschlagene Werte ausgeben",0
.db "   ",0
.db "W* Werte ausgeben (Beispielcode)",0
;.db "   LD r1,X+      2 Taktzyklen",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "   SHR r1        1 Taktzyklus",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "   SHR r1        1 Taktzyklus",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "   SHR r1        1 Taktzyklus",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "   SHR r1        1 Taktzyklus",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "   SHR r1        1 Taktzyklus",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "   SHR r1        1 Taktzyklus",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "   SHR r1        1 Taktzyklus",0
;.db "   OUT PORTA,r1  1 Taktzyklus",0
;.db "               ===============",0
;.db "                17 Taktzyklen",0
.db "   17 Taktzyklen f",$FC,"r 8 Pixel ",0
.db "W  ",0
.db "C  ",0
.db " ######################################",0
.db " #          Systemroutinen            #",0
.db " #    (Schnittstellen zum Kernel)     #",0
.db " ######################################",0
.db "   ",0
.db "   ",0
.db "W* Zeichen von Tastatur holen",0
.db " ",0
.db "W* String von Tastatur in Speicher holen ",0
.db "   ",0
.db "W* Zeichen auf Anzeige ausgeben",0
.db "   ",0
.db "W* Hochrollen",0
.db "   ",0
.db "W* Herunterrollen",0
.db "W  ",0
.db "C  ",0
.db " ######################################",0
.db " #            Programme               #",0
.db " ######################################",0
.db "   ",0
.db "   ",0
.db "W* Diese Pr",$E4,"sentation",0
.db "   ",0
.db "W* Rennspiel ",0
.db "   ",0
.db "W* Flugsimulator ",0
.db "   ",0
.db "W* Zufallszeichen",0
.db "W  ",0
.db "W  ",0
.db "C  ",0
.db " ######################################",0
.db " #                                    #",0
.db " #   Vielen                           #",0
.db " #         Dank                       #",0
.db " #             f",$FC,"r                    #",0
.db " #                Ihre                #",0
.db " #                   Aufmerksamkeit!  #",0
.db " #                                    #",0
.db " ######################################",0
.db "W  ",0
.db "E  ",0



fh_logo:
.db "C  ",0
.db " ############ FACHHOCHSCHULE REGENSBURG",0
.db " ############",0
.db " ############ UNIVERSITY OF",0
.db " ############ APPLIED SCIENCES ",0
.db " ############",0
.db " | ##########",0
.db " |  #########",0
.db " | ########## HOCHSCHULE F",$FC,"R ",0
.db " ############",0
.db " |\         |",0
.db " | \        | TECHNIK",0
.db " |  \       |",0
.db " |   |      |",0
.db " |   |      | WIRTSCHAFT ",0
.db " |   |      |",0
.db " |   |      |",0
.db " |   |      | SOZIALWESEN",0
.db " |    \     |",0
.db " |_____|____|",0
.db "W  ",0
.db "E  ",0