.def roadpos=r20
.def autopos=r21
.def punktestand=r22

rennspiel:
  LDI punktestand,$ff
  LDI roadpos,13
  LDI autopos,13+5
  ;call clear_screen
  rennspiel_loop:
   call get_key_r17
   CPI r17,kesc
   BREQ rennspiel_end
   CPI r17,kleft
   BREQ rennspiel_left
   CPI r17,kright
   BREQ rennspiel_right
   rjmp rennspiel_key_done
   rennspiel_left:
     dec autopos
     rjmp rennspiel_key_done
   rennspiel_right:
     inc autopos
     rjmp rennspiel_key_done
   rennspiel_key_done:
    cpi autopos,39
    BRGE rennspiel_end
    cpi autopos,0
    BRLT rennspiel_end
   call sleep_frame
   call scroll_down
   call zeichne_strasse
   call zeichne_auto
   
   LDI r17,linecount-1
   STS text_pos_y,r17
   LDI r17,0
   STS text_pos_x,r17
   mov r17,punktestand
   call display_byte_hex_r17
   
   
  rjmp rennspiel_loop
  rennspiel_end:
 ret  
  
  
zeichne_strasse:
   call get_random_number_r17
   ANDI r17,7
   CPI r17,0
   BRNE zeichne_strasse_endrandom
   call get_random_number_r17
   ANDI r17,1
   CPI r17,0
   BRNE zeichne_strasse_dec
   inc roadpos
   rjmp zeichne_strasse_endrandom
   zeichne_strasse_dec:
   dec roadpos
   
   zeichne_strasse_endrandom:	
   CPI roadpos,26
   BRGE zeichne_strasse_to_big
   CPI roadpos,0
   BRLT zeichne_strasse_to_small
   rjmp zeichne_strasse_draw
   zeichne_strasse_to_big:
   LDI roadpos,25
   rjmp zeichne_strasse_draw
   zeichne_strasse_to_small:
   LDI roadpos,0
   zeichne_strasse_draw:
   LDI r17,0
   call clear_line_r17
   STS  text_pos_x,roadpos
   LDI r17,0
   STS text_pos_y,r17
   LDI zh,high(strassenbild*2)
   LDI zl,low(strassenbild*2)
   call write_string_z_pm
 ret

zeichne_auto:
  STS text_pos_x,autopos
  LDI r17,linecount-1
  STS text_pos_y,r17
  call get_char_r17
  CPI r17,'#'
  BREQ gegen_die_bande
  LDI r17,'A' 
  call out_char_r17
 ret
gegen_die_bande:
  SUBI punktestand,1
 ret
 
strassenbild: .db "##          ##",0,0